#!/usr/bin/perl -w
# read in a perflog output and yield a table

print("benchmark     orig   infer  ratio  sf/sq/d\n");
print("---------    -----  ------  -----  -------\n");

$line = rdln();
while ($line) {
  $name = $line;
  $name =~ s/[0-9]+\.//;
  $name =~ s,olden/,,;
  $name =~ s/:$//;
  diagnostic("name: $name\n");

  expect("orig");
  ($orig) = (rdln() =~ /median: (.*)s/);
  diagnostic("  orig: $orig\n");
  rdln5();

  expect("cil");
  ($cil) = (rdln() =~ /median: (.*)s/);
  diagnostic("  cil: $cil\n");
  rdln5();

  expect("inferbox");

  # parse the pointer kind breakdown
  expect("contains");
  ($safe) = readPct(rdln());;
  #diagnostic("safe: $safe\n");

  $line = rdln();
  $seq = 0;
  while ($line !~ /median/ && $line !~ /WILD/) {
    $seq += readPct($line);
    $line = rdln();
  }
  $wild = 0;
  if ($line =~ /WILD/) {
    $wild = readPct($line);
    $line = rdln();
  }
  diagnostic("  sf/sq/d: $safe/$seq/$wild\n");

  ($infer) = ($line =~ /median: (.*)s/);
  rdln5();
  diagnostic("  infer: $infer\n");

  $line = rdln();

  printf("%-9s   %6.3f  %6.3f  %5.3f  $safe/$seq/$wild\n",
         $name, $orig, $infer, $infer / $orig);
}


sub rdln {
  my $ret = scalar(<STDIN>);
  if (defined($ret)) {
    $ret = trim($ret);
  }
  return $ret;
}

sub rdln5 {
  rdln(); rdln(); rdln(); rdln(); rdln();
}

sub trim {
  my ($line) = @_;
  $line =~ s/^[ \t]*//;
  $line =~ s/[ \t\n]*$//;
  return $line;
}

sub expect {
  my ($pat) = @_;
  my $line = rdln();
  #diagnostic("line: $line\n");
  if ($line !~ /$pat/) {
    die "expected $pat\n";
  }
}

sub readPct {
  my ($line) = @_;
  my ($ret) = ($line =~ / - \d+ \([ ]*(\d+)%\)/);
  return $ret;
}

sub diagnostic {
  #print(@_);
}
