/* Include file for preprocessing before and after conversion to safec */
/* Included before the boxing with CCURED defined, and also after boxing */

/************* INLINE STUBS for C LIBRARY FUNCTIONS */

#ifndef CCURED_NO_GC
#define malloc      ccured_malloc
#define calloc      ccured_calloc
#define realloc     ccured_realloc
#define free        ccured_free
#define explicit_gc ccured_explicit_gc
#endif

/* weimer */
#ifndef __cdecl
#define __cdecl
#endif
#ifndef NULL
#define NULL 0
#endif
//#include <string.h>

void *   __scalar2pointer(unsigned long  l , int  fid , int  lid ) ;

//#define NO_CHECKS
#ifdef NO_CHECKS
#define  CHECK_FETCHLENGTH(   p ,    b ) 0
#define  CHECK_FETCHSTRINGEND(   s ) ;
#define  CHECK_STRINGMAX(   p ,    b ) ;
#define  CHECK_FETCHEND(   p ,    b ) 0
#define  CHECK_LBOUND(   b ,    p ) ;
#define  CHECK_UBOUND(   bend ,    p ,  pl ) ;
#define  CHECK_BOUNDS(   b ,    bend ,    p , pl ) ;
#define  CHECK_BOUNDS_LEN(   b ,  bl ,    p , pl ) ;
#define  CHECK_FATPOINTERREAD(   b ,  nrWords , p ) ;
#define  CHECK_FATPOINTERWRITE(   b , nrWords , p ,    wb ,    wp ) ;
#define  CHECK_FATSTACKPOINTER(   p ,    b ) ; 
#define  CHECK_LEANSTACKPOINTER(   p ) ;
#define  CHECK_FUNCTIONPOINTER(a,b) ; 
#define  CHECK_ZEROTAGS(   b ,  bl ,    p , size , offset ) ;
#define  CHECK_POSITIVE(x ) ;
#define  CHECK_SAFERETFAT(a,b) ;
#define  CHECK_NULL(p) ;
#define  CHECK_SAFEFATLEANCAST(a,b) ;

#else // NO-CHECKS

#include "safeccheck.h"

#endif // NO-CHECKS


//
//
// WRAPPERS
//
//


// sm: struct _stat doesn't exist in linux
#ifdef _GNUCC
#define _stat stat
#define __builtin_memset_ww memset_ww
#define __builtin_memset_ff memset_ff
#define __builtin_memset_qq memset_qq
#define __builtin_memset_sf memset_sf
#endif


// Now define away some attributes used in the inference of types
#ifndef __NODE

#define __NODE(x)
#define __SAFE
#define __INDEX
#define __TAGGED
#define __FSEQ
#define __SEQ
#define __WILD
#define __SIZED
#define __RWSTRING
#define __ROSTRING
#define __NULLTERM
#define __SEQN
#define __FSEQN
#define __SAFEUNION
#define __WILDT
#define __FSEQT
#define __SEQT
#define __FSEQNT
#define __SEQNT
#define __INDEXT
#define __HEAPIFY
#define __BOXMODEL
#define __MODELEDBODY
#define __BOXVARARG(x)
#define __BOXFORMAT(x)
#define __NOBOX
#endif

#ifdef _MSVC
#pragma warning(disable: 4068) // Unrecognized pragma
#endif
