(*
 *
 * Copyright (c) 2001 by
 *  George C. Necula	necula@cs.berkeley.edu
 *  Scott McPeak        smcpeak@cs.berkeley.edu
 *  Wes Weimer          weimer@cs.berkeley.edu
 *   
 * All rights reserved.  Permission to use, copy, modify and distribute
 * this software for research purposes only is hereby granted, 
 * provided that the following conditions are met: 
 * 1. Redistributions of source code must retain the above copyright notice, 
 * this list of conditions and the following disclaimer. 
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 * this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution. 
 * 3. The name of the authors may not be used to endorse or promote products 
 * derived from  this software without specific prior written permission. 
 *
 * DISCLAIMER:
 * THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS OR 
 * IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED WARRANTIES 
 * OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE ARE DISCLAIMED. 
 * IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY DIRECT, INDIRECT, 
 * INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING, 
 * BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES; LOSS 
 * OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER CAUSED AND ON 
 * ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT LIABILITY, OR TORT 
 * (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF 
 * THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
 *
 *)

(* Some utility functions for the solver *)

val subtype: t1:Cil.typ -> q1:Ptrnode.opointerkind -> 
             t2:Cil.typ -> q2:Ptrnode.opointerkind -> bool


(* are the given two types congurent? see infer.tex 
 * also remember that two wild pointers are always considered congruent *)
val type_congruent: t1:Cil.typ -> q1:Ptrnode.opointerkind ->
                    t2:Cil.typ -> q2:Ptrnode.opointerkind -> bool


(* a predicate to determine if a polymorphic function call is involved 
val is_p: Ptrnode.node -> Ptrnode.node -> bool *)



(* This "solver" turns almost all nodes WILD *)
val wild_solve: (int,Ptrnode.node) Hashtbl.t -> bool


(* table all the interface nodes in the graph *)
val table_interface: (int,Ptrnode.node) Hashtbl.t -> unit

(* table every node in the graph *)
val table_it_all: (int,Ptrnode.node) Hashtbl.t -> unit
